
{
  Simple dmineur pour Windows sans bibliothque de composants visuels.
  Traduction en Pascal du dmineur en C de "CGi".
  http://chgi.developpez.com/wincode/demineur/
}

program demineur;

{$WARN SYMBOL_PLATFORM OFF}

{$IFDEF FPC}
  {$APPTYPE GUI}
  {$R 'demineur.res'}
{$ELSE}
  {$R 'demineur.res' 'demineur.rc'}
{$ENDIF}

uses
  Messages,
  Windows,
  SysUtils,
  
  demineur_u1,
  demineur_u2,
  demineur_u3;

const
  IDM_QUIT  = 101;
  IDM_NEW   = 102;
  IDM_ABOUT = 103;
  LARGEUR   =  32;
  
var
  hFenetre: HWND;
  hMenu, hSousMenu: THandle;
  mines: TMines;
  fin: boolean;
  
function WndProc(hWnd: HWND; msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
  x, y, xMouse, yMouse: integer;
  oldPen, newPen: HPEN;
  DC, auxDC: HDC;
  hBmp: HBITMAP;
  ps: TPaintStruct;
  r1, r2: TRect;
  hBsh: HBRUSH;
  couleur: LongWord;
begin
  case msg of
    WM_CREATE:
      begin
        Randomize;
        mines := NouvellesMines;
        fin := FALSE;
        result := 0;
        exit;
      end;
    WM_COMMAND:
      case LoWord(wParam) of
        IDM_QUIT: PostMessage(hWnd, WM_CLOSE, 0, 0);
        IDM_NEW:
          begin
            mines := NouvellesMines;
            fin := FALSE;
            InvalidateRect(hWnd, nil, FALSE);
          end;
        IDM_ABOUT: MessageBox(0, APROPOS, PROGRAMME, MB_OK);
      end;
    WM_LBUTTONUP:
      begin
        xMouse := LoWord(lParam);
        yMouse := HiWord(lParam);
        x := xMouse div LARGEUR;
        y := yMouse div LARGEUR;
        InvalidateRect(hWnd, nil, FALSE);
        if fin then
        begin
          result := 0;
          exit;
        end;
        if DecouvreYX(mines, y, x) then
        begin
          DecouvreTout(mines);
          MessageBox(0, PERDU, PROGRAMME, MB_OK);
          fin := TRUE;
        end else
          if ToutesLesMinesTrouvees(mines) then
          begin
            MessageBox(0, REUSSI, PROGRAMME, MB_OK);
            fin := TRUE;
          end;
        result := 0;
        exit;
      end;
    WM_KEYDOWN:
      begin
        if wParam = VK_ESCAPE then
        begin
          PostQuitMessage(0);
          result := 0;
          Exit;
        end;
      end;
    WM_DESTROY:
      begin
        PostQuitMessage(0);
        result := 0;
        Exit;
      end;
    WM_PAINT:
    begin
      hBsh := CreateSolidBrush($D0D0D0);
      newPen := CreatePen(PS_SOLID, 1, $303030);
      GetClientRect(hWnd, r1);
      DC := BeginPaint(hFenetre, ps);

      auxDC := CreateCompatibleDC(DC);
      hBmp := CreateCompatibleBitmap(DC, r1.right, r1.bottom);
      SelectObject(auxDC, hBmp);
      oldPen := SelectObject(auxDC, newPen);

      FillRect(auxDC, r1, CreateSolidBrush($C0C0C0));
      
      for y := 0 to NOMBRE_LIGNES - 1 do
        for x := 0 to NOMBRE_COLONNES - 1 do
        begin
          r2.left := x * LARGEUR + 1;
          r2.right := x * LARGEUR + LARGEUR;
          r2.top := y * LARGEUR + 1;
          r2.bottom := y * LARGEUR + LARGEUR;

          Rectangle(auxDC, r2.left, r2.top, r2.right, r2.bottom);
          
          if EstCouvert(mines[y, x]) then
          begin
            Inc(r2.left);
            Dec(r2.right);
            Inc(r2.top);
            Dec(r2.bottom);
            FillRect(auxDC, r2, hBsh);
          end else  
            if EstUneMine(mines[y, x]) then
            begin
              SetTextColor(auxDC, 0);
              DrawText(auxDC, MINE, 1, r2, DT_CENTER or DT_VCENTER or DT_SINGLELINE);
            end else  
              if EstUnNombre(mines[y, x]) then
              begin
                case ExtraitNombre(mines[y, x]) of
                  1:   couleur := $FF0000;
                  2:   couleur := $228B22;
                  else couleur := $0000FF;
                end;
                SetTextColor(auxDC, couleur);
                DrawText(
                  auxDC,
                  pChar(IntToStr(ExtraitNombre(mines[y, x]))),
                  1,
                  r2,
                  DT_CENTER or DT_VCENTER or DT_SINGLELINE
                );
              end;
        end;
      
      BitBlt(DC, 0, 0, r1.right, r1.bottom, auxDC, 0, 0, SRCCOPY);

      DeleteDC(auxDC);
      DeleteObject(hBmp);
      EndPaint(hFenetre, ps);
      DeleteObject(hBsh);
      SelectObject(DC, oldPen);
      DeleteObject(newPen);
      result := 0;
      Exit;
    end;
  end;
  result := DefWindowProc(hWnd, msg, wParam, lParam);
end;

procedure ClientResize(aHandle: HWND; aWidth, aHeight: integer);
var
  cr, wr: TRect;
  d: TPoint;
begin
  GetClientRect(aHandle, cr);
  GetWindowRect(aHandle, wr);
  d.x := (wr.right - wr.left) - cr.right;
  d.y := (wr.bottom - wr.top) - cr.bottom;
  MoveWindow(aHandle, wr.left, wr.top, aWidth + d.x, aHeight + d.y, true);
end;

var
  wc: TWndClass;
  msg: TMsg;
  
begin
  wc.Style := CS_VREDRAW or CS_HREDRAW;
  wc.lpfnWndProc := @WndProc;
  wc.cbClsExtra := 0;
  wc.cbWndExtra := 0;
  wc.hInstance := hInstance;
  wc.hIcon := LoadIcon(hInstance, MakeIntResource(1));
  wc.hCursor := LoadCursor({hInstance}0, IDC_ARROW);
  wc.hbrBackground := CreateSolidBrush($C0C0C0);
  wc.lpszMenuName := nil;
  wc.lpszClassName:= PROGRAMME;
  RegisterClass(wc);

  hSousMenu := CreateMenu;
  AppendMenu(hSousMenu, MF_STRING, IDM_NEW, NOUVELLE_PARTIE);
  AppendMenu(hSousMenu, MF_STRING, IDM_ABOUT, ITEM_APROPOS);
  AppendMenu(hSousMenu, MF_STRING, IDM_QUIT, QUITTER);
  hMenu := CreateMenu;
  AppendMenu(hMenu, MF_POPUP, hSousMenu, JEU);
  
  hFenetre := CreateWindow
  (
    PROGRAMME,
    PROGRAMME,
    WS_SYSMENU or WS_CAPTION or WS_MINIMIZEBOX,
    integer(CW_USEDEFAULT),
    integer(CW_USEDEFAULT),
    LARGEUR * NOMBRE_COLONNES + 1 + 2 * GetSystemMetrics(sm_CXFrame),
    LARGEUR * NOMBRE_LIGNES + 1 + GetSystemMetrics(sm_CYCaption) + GetSystemMetrics(sm_CYMenu) + 2 * GetSystemMetrics(sm_CYFrame),
    0,
    hMenu,
    HInstance,
    nil
  );
  
  ShowWindow(hFenetre, CMDSHOW);
  UpdateWindow(hFenetre);
  
  ClientResize(hFenetre, LARGEUR * NOMBRE_COLONNES + 1, LARGEUR * NOMBRE_LIGNES + 1);
  
  repeat
    if PeekMessage(msg, 0, 0, 0, PM_REMOVE) then
    begin
      TranslateMessage(msg);
      DispatchMessage(msg);
    end;
  until msg.message = WM_QUIT;
  
  ExitProcess(msg.wParam);
end.
