
unit demineur_u2;

{$IFDEF FPC}
{$MODE DELPHI}
{$ENDIF}

interface

function EstUneMine(const i: integer): boolean;
function EstCouvert(const i: integer): boolean;
function EstUnNombre(const i: integer): boolean;
function ExtraitNombre(const i: integer): integer;
procedure PoseMine(var i: integer);
procedure Recouvre(var i: integer);
procedure Decouvre(var i: integer);

implementation

const
  MINE    = $00000100;
  COUVERT = $00010000;
  NOMBRE  = $0000000F;

function EstUneMine(const i: integer): boolean;
begin
  result := (i and MINE) > 0;
end;

function EstCouvert(const i: integer): boolean;
begin
  result := (i and COUVERT) > 0;
end;

function EstUnNombre(const i: integer): boolean;
begin
  result := ExtraitNombre(i) > 0;
end;

function ExtraitNombre(const i: integer): integer;
begin
  result := i and NOMBRE;
end;

procedure PoseMine(var i: integer);
begin
  i := i or MINE;
end;

procedure Recouvre(var i: integer);
begin
  i := i or COUVERT;
end;

procedure Decouvre(var i: integer);
begin
  i := i and not COUVERT;
end;

end.
